; ATTR port test by Simon Owen <simon@simonowen.com>

lmpr:          equ  250             ; Low Memory Page Register
hmpr:          equ  251             ; High Memory Page Register
rom0_off:      equ  %00100000       ; ROM0 off bit in LMPR

base:          equ  &8000

               autoexec

               org  base
               dump $

               halt                 ; wait until safe period after interrupt

               in   a,(hmpr)        ; read our current code page
               and  %00011111       ; keep only page number bits
               or   rom0_off        ; set ROM0 off
               out  (lmpr),a        ; page us in at &0000

               halt                 ; ensure we're executing NOPs in run up to
                                    ; the test code, for consistent start point

               org  &0038           ; INT
               dump $+base

int:           ld   hl,loop
               ld   bc,&00f8        ; CLUT position 0
loop:          in   a,(255)         ; read ATTR port
               out  (c),a           ; set colour 0
               jp   (hl)            ; quick jump back


               org  &0066-4         ; NMI-4
               dump $+base

nmi_page:      ld   a,%00011111     ; ROM0 + BASIC variables
               out  (lmpr),a        ; page in and hit ROM NMI code
nmi:           jr   nmi_page        ; jump back to paging code


               ; Ensure things are where there should be
               ASSERT(int == &0038)
               ASSERT(nmi == &0066)
